<?php

namespace General\Models;

use Illuminate\Support\Facades\DB;

trait TableSuffix
{
    private static $suffix;

    public static function suffix($suffix)
    {
        static::$suffix = $suffix;
    }

    public function __construct(array $attributes = [])
    {
        $this->table .= static::$suffix;
        parent::__construct($attributes);
    }

    public static function model(string $suffix)
    {
        self::suffix($suffix);
        $model = new self;
        return $model;
    }

    public static function IndexRaw($index_raw)
    {
        $model = new static();
        $name = "{$model->getTable()} use index ({$index_raw})";
        $model->setTable(DB::raw($name));
        return $model;
    }
}
