<?php

namespace General\Services\LandingPage;

use App\Consts\BaseConst;
use Exception;
use General\Helpers\CommonHelper;
use GuzzleHttp\Client;

class Report
{
    public function report(string $path, array $query_params)
    {
        $client = new Client(['timeout' => 3]);
        $query_params['sign'] = CommonHelper::sign($query_params,  BaseConst::TIKTOK_KEY);
        try {
            \Log::info('report_call_addreport_count:'.json_encode($query_params));
            $response =  $client->post(env('TRACK_API_DOMAIN') . '/' . $path, ['form_params' => $query_params]);
            if ($response->getStatusCode() == 200) {
                $result = $response->getBody()->getContents();
                myLog('track_api')->info($result);
                return json_decode($result, true);
            } else {
                return [];
            }
        } catch (Exception $e) {
            myLog('track_api')->error($e->getMessage());
        }
    }
}
